library jaguar.example.routes.simple;

import 'dart:async';
import 'package:jaguar/jaguar.dart';

part 'simple.g.dart';

class SampleInterceptor extends Interceptor {
  FutureOr<Null> pre(Context ctx) {
    //TODO
    return null;
  }
}

/// Example of basic API class
@Api(path: '/api')
class SubGroup {
  SampleInterceptor sampleInterceptor(Context ctx) => new SampleInterceptor();

  /// Example of basic route
  @Route(path: '/ping')
  @Wrap(const [#sampleInterceptor])
  String normal(Context ctx) => "You pinged me!";

  @Post(path: '/:id')
  @WrapOne(#sampleInterceptor)
  Map postRoute(Context ctx) => {
    "Hello": "Dart",
  };

  @Put(path: '/:id')
  void voidRoute(Context ctx) {}
}

/// Example of basic API class
@Api(path: '/api')
class MotherGroup {
  /// Example of basic route
  @Route(path: '/ping')
  String ping(Context ctx) => "You pinged me!";

  @IncludeApi(path: '/sub')
  final SubGroup subGroup = new SubGroup();
}
